// code by jph


// TODO for wave: explicitly joinable // ensure that join() works!
//    pthread_t thread[NUM_THREADS];
//    pthread_attr_t attr;
//    /* Initialize and set thread detached attribute */
//    pthread_attr_init(&attr);
//    pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_JOINABLE);



class aniBoat : public aniFloatable {
public:
  aniBoat();
  void scene(void);
  void drawUtil(void);
  char* toString(void) { return "aniBoat"; };
  
  tensor<double> lev;
  control<double> bos;
  control<double> ste;
  audio eng;
  double sub;
};

aniBoat::aniBoat() : 
  aniFloatable("get/mesh/long_72_cnv",
    "get/mesh/longint_272.arr",18.0, // 386 466
    "get/mesh/longext_262_v.arr",
    "get/mesh/longext_262_n.arr",50.0),
  eng("get/audio/boat.wav",FMOD_LOOP_NORMAL|FMOD_3D)
{
  ine*=0.05; // boats are light-weight
  bos.MU=0.5;
  lev=tensor<double>::vector(4).as(-3.5, 0.0,-0.5, 1.0);
  sub=0;
}

void aniBoat::scene(void) {
  
  // TODO visualize propeller  
  acc-=glI(pos)[2]*9.81;
  int hum=this==aniMated::humanized;
  
  bos.cn=(keyboard(KEY_AU)-keyboard(KEY_AD))*hum*(2-(sub<0));
  ste.vn=(keyboard(KEY_AR)-keyboard(KEY_AL))*hum;
  control<double>::dt=opengl_rate.s();
  bos.EXACT_integrate();
  if (sub<0) {
    tensor<double> frc=tensor<double>::vector(4).as( 
      cos(ste.vn)*bos.vn*5*opengl_slider("dinghy accel",0.5),
      sin(ste.vn)*bos.vn*2*opengl_slider("dinghy rotation",0.3),
      0.0, 0.0);
    acc+=frc;
    tor+=lev.x(frc);
  }
  eng.vol=0.5+0.3*abs(bos.vn);
  double bla=(vel+pos*ome.x(lev)).norm()*0.1;
  eng.doppler(1+abs(bos.vn)*bla);
  eng.pos=pos*lev;
  eng.vel=vel;
  eng.play();
  //opengl_label_add(pos[3],tensor<double>::string( bos.vn ));   
}

void aniBoat::drawUtil(void) {
  //printf("%6.3f \n",bos.pn);
  tensor<double> mat=glD(tensor<double>(1,4).as( bos.pn, 0.0, 0.0, 0.0)).exp();
  glPushMatrix();
    //glMultMatrixd(mat.data);
    glTranslated(lev(0),lev(1),lev(2));
    glRotatef( ste.vn*30, 0.0, 0.0, 1.0);
    glRotatef( bos.pn*300, 1.0, 0.0, 0.0);
    glScaled( 0.1, 1,1);
    glutWireSphere(1,10,10);
  glPopMatrix();
}


