// code by jph

class aniFloatable : public aniMated {
public:
  aniFloatable(char* msh_,char* ins_,double buo,char* ext_,char* nrm_,double res);
  void scene(void);
  void draw(void);
  virtual void drawUtil(void);
  char* toString(void) { return "aniFloatable"; };
  tensor<double> ins;
  tensor<double> ins_dsp;
  tensor<double> ext;
  tensor<double> ext_dsp;
  tensor<double> nrm;
  tensor<double> cum;
  double buoyancy;
  double resist;
};

aniFloatable::aniFloatable(char* msh_,char* ins_,double buo,char* ext_,char* nrm_,double res) {
  msh=new meshgl(*opengl_meshgl(msh_));
  shd=msh;
  ine=msh->inertia();
  rap.set(msh);
  // buoyancy
  ins=tensor<double>(ins_);
  buoyancy=buo/ins.size[1]; // if buo == 9.81 then aniFloatable maintains depth if fully submerged and at rest
  
  ins_dsp=ins*0;
  ext=tensor<double>(ext_);
  ext_dsp=ext*0;
  nrm=tensor<double>(nrm_);
  resist=res/ext.size[1];
  
  cum=tensor<double>::randn(1,nrm.size[1])*0.1; // accumulation buffer for each exterior normal to generate particles
  //fva=1; // in case no friction from the water
  //fot=1;
}

void aniFloatable::scene(void) {
}

void aniFloatable::draw(void) {
  msh->draw();
  if (0) {
    glPointSize(2);
    glBegin(GL_POINTS);
      glColor3d( 1.0, 0.0, 0.0);
      for (int c0=0;c0<ext.numel;c0+=4)
        glVertex3dv(ext^c0);
    glEnd();
    glLineWidth(1);
    glBegin(GL_LINES);
      glColor3d( 0.0, 1.0, 0.0);
      for (int c0=0;c0<ext.size[1];++c0) {
        glVertex3dv(ext^c0*4);
        glVertex3dv((ext[c0]+nrm[c0]*cum.data[c0]).data);
      }
    glEnd();    
  }
  ext_dsp=0;
  
  if (0) {
    glLineWidth(1);
    glBegin(GL_LINES);
      glColor3d( 0.0, 1.0, 0.0);
      for (int c0=0;c0<ins.size[1];++c0) {
        glVertex3dv(ins^c0*4);
        glVertex3dv((ins[c0]+ins_dsp[c0]*2).data);
      }
    glEnd();
  }
  ins_dsp=0;
  drawUtil();
}

void aniFloatable::drawUtil(void) {
}
