// code by jph

class aniLink1 : public aniLink { // hinge
public:
  aniLink1(aniMated* ani0,tensor<double> lev0,
           aniMated* ani1,tensor<double> lev1,
           tensor<double> dir,double rev,
           double fmu);
  void setAxis(tensor<double> dir);
  void draw(void);
  char* toString(void) { return "aniLink1"; };
};

aniLink1::aniLink1(aniMated* ani0,tensor<double> lev0,
         aniMated* ani1,tensor<double> lev1,
         tensor<double> dir,double rev,
         double fmu) : aniLink(ani0,lev0,ani1,lev1,dir,rev,fmu) {
  dir(3)=0;
  dir=dir.normal();
  setAxis(dir);
  rank=5;
  isConsistent();
}

void aniLink1::setAxis(tensor<double> dir) {
  axs[0]=ani[0]->pos.solve(dir);
  axs[1]=ani[1]->pos.solve(dir);
  shf[0]=glMatrixFromVector(axs[0]       ,lev[0]);
  shf[1]=glMatrixFromVector(axs[1]*(-1.0),lev[1]);
  double mss=0.3;
  cnL[0]=glMatrixFromVector(lev[0]+axs[0]*mss,tensor<double>(1,3));
  cnL[1]=glMatrixFromVector(lev[1]+axs[1]*mss,tensor<double>(1,3));
  cnR[0]=glMatrixFromVector(lev[0]-axs[0]*mss,tensor<double>(1,3));
  cnR[1]=glMatrixFromVector(lev[1]-axs[1]*mss,tensor<double>(1,3));
}

void aniLink1::draw(void) {
  double mss=0.3;
  double bse;
  double hgt;
  glLineWidth(1);
  //opengl_label_add(ani[0]->pos*lev[0],tensor<char>::string(ctr.toString()));  
  for (int c0=0;c0<2;++c0) {
    bse=0.05;
    glPushMatrix();
      glMultMatrixd(ani[c0]->pos.data);
      glColor4dv(ani[c0]->col.data);
      if (0) { // TODO keypress
        glPushMatrix();
          glMultMatrixd(trf[c0].data);
          hgt=gl3v(lev[c0]).norm();
          glutSolidCone(0.05+bse,hgt,5+bse*50,5+hgt*5);
        glPopMatrix();
      } else {
        glPushMatrix();
          glMultMatrixd(cnL[c0].data);
          hgt=gl3v(lev[c0]+axs[c0]*mss).norm();
          glutSolidCone(0.05+bse,hgt,10,5+hgt*5);
        glPopMatrix();
        glPushMatrix();
          glMultMatrixd(cnR[c0].data);
          hgt=gl3v(lev[c0]-axs[c0]*mss).norm();
          glutSolidCone(0.05+bse,hgt,10,5+hgt*5);
        glPopMatrix();
      }
      glPushMatrix();
        glMultMatrixd(shf[c0].data);
        glutSolidCylinderbw(0,mss,0.2,50,5,ani[c0]->col);
      glPopMatrix();
    glPopMatrix();
  }
}
  
