// code by jph

tensor<int> patch3_edg=tensor<int>("get/flow/patch_3.edg"); // TODO  this is crap
tensor<int> patch4_edg=tensor<int>("get/flow/patch_4.edg");
tensor<int> patch5_edg=tensor<int>("get/flow/patch_5.edg");

class aniPatch {
public:
  aniPatch(tensor<char> str,double rad,tensor<double> txc,int order,int level);
  ~aniPatch(void);
  
  void scene(void);
  void draw(void);
  
  double norm(void);
  char* toString(void) { return "aniPatch"; };
  
  meshgl*   msh;
  double    rad;
  double    alp; // alpha blending value 0...1
  double    psh; // increment for alpha
  double    nrm; // 1 / original edge length
  int       ord; // counter for drawing order
  int       lev; // patch resolution = 3,4,5
};

aniPatch::aniPatch(tensor<char> str,double radius,tensor<double> txc,int order,int level) {
  assert(1<txc.numel);
  assert(TENSOR_NO_DIVISION<radius);
  assert(2<level&&level<6);
  rad=radius;
  ord=order;
  lev=level;
  char fnc[80];
  sprintf(fnc,"get/flow/patch_%i",lev);
  msh=new meshgl(*opengl_meshgl(fnc));
  //msh->blend=1;
  sprintf(fnc,"get/flow/%s/%02i.tex",(str&0).data,random<int>::uniform(16));
  msh->texture=opengl_texture(fnc);
  int v3f=msh->offsetV3F();
  nrm=1/(msh->arr(v3f,2)-msh->arr(v3f,1));
  //printf("NORM %f\n",nrm);
  double ang=random<double>::uniform()*MATH_2PI; // rotate around random angle
  float px,py;
  for (int c0=v3f;c0<msh->arr.numel;c0+=msh->arr.size[0]) {
    px=msh->arr.data[c0+0];
    py=msh->arr.data[c0+1];
    msh->arr.data[c0+0]=( cos(ang)*px+sin(ang)*py)*rad+txc.data[0];
    msh->arr.data[c0+1]=(-sin(ang)*px+cos(ang)*py)*rad+txc.data[1];
  }
  psh=0;
  alp=0;
}

aniPatch::~aniPatch(void) {
  delete msh;
}

void aniPatch::scene(void) {
  //tensor<double> vrt(1,4);
  //for (int c0=msh->offsetV3F();c0<msh->arr.numel;c0+=msh->arr.size[0]) {
  //  msh->arr.data[c0+0]+=random<double>::normal()*0.001;
  //  msh->arr.data[c0+1]+=random<double>::normal()*0.001;    
  //}
  //opengl_bulletin.add(tensor<double>::string( norm() ));  
}

double aniPatch::norm(void) {
  int c0;
  double ret=0;
  double lmx=0;
  double net=nrm/rad;
  int v3f=msh->offsetV3F();
  tensor<float> v0(1,3),v1(1,3);
  switch (lev) { 
    case 3:
      for (c0=0;c0<patch3_edg.numel;c0+=2) {
        v0.in(0,&msh->arr(v3f,patch3_edg.data[0+c0]),3);
        v1.in(0,&msh->arr(v3f,patch3_edg.data[1+c0]),3);
        lmx=(v0-v1).norm()*net;
        if (lmx<1)
          lmx=1/lmx;
        ret=max(ret,lmx-1);
      }
      break;
    case 4:
      for (c0=0;c0<patch4_edg.numel;c0+=2) {
        v0.in(0,&msh->arr(v3f,patch4_edg.data[0+c0]),3);
        v1.in(0,&msh->arr(v3f,patch4_edg.data[1+c0]),3);
        lmx=(v0-v1).norm()*net;
        if (lmx<1)
          lmx=1/lmx;
        ret=max(ret,lmx-1);
      }
      break;
    case 5:
      for (c0=0;c0<patch5_edg.numel;c0+=2) {
        v0.in(0,&msh->arr(v3f,patch5_edg.data[0+c0]),3);
        v1.in(0,&msh->arr(v3f,patch5_edg.data[1+c0]),3);
        lmx=(v0-v1).norm()*net;
        if (lmx<1)
          lmx=1/lmx;
        ret=max(ret,lmx-1);
      }
      break;
  }
  return ret;
}

void aniPatch::draw(void) {
  //glDepthFunc(GL_LEQUAL);
  glDepthMask(GL_FALSE);
  msh->color(3)=alp; // other part remains white!
  msh->draw();
  if (keyboard(';')) {
    glColor3d(psh<0,0<psh,0);
    glPointSize(2);
    glBegin(GL_POINTS);
      glVertex3fv(&msh->arr.data[5]);
    glEnd();
    if (0<psh) {
      glPushMatrix();
        glTranslatef(msh->arr.data[5],msh->arr.data[6],0);
        glutWireDisc(rad,20);
      glPopMatrix();
    }
  }
  glDepthMask(GL_TRUE);
  //glDepthFunc(GL_LESS);
}

