// code by jph

#ifndef DISJOINT_INCLUDED
#define DISJOINT_INCLUDED

template<class type>
class disjoint {
public:
  disjoint<type>(const type& copy);             // ok (!makeset!)
  void            remake(const type& copy);     // ok (!makeset!)
  disjoint<type>* find(void);                   // ok (!path compression!)
  void            join(disjoint<type>* set);    // ok (!union by rank!)
//----------------------------------------------------------------------
  disjoint<type>* prev;             // points to previous node
  int rank;                         // 
  type data;                        // content
};

template<class type>
disjoint<type>::disjoint(const type& copy) {
  prev=this;
  rank=0;
  data=copy;
}

template<class type>
void disjoint<type>::remake(const type& copy) {
  prev=this;
  rank=0;
  data=copy;
}

template<class type>
disjoint<type>* disjoint<type>::find(void) {
  if (this!=prev)
    prev=prev->find(); // TODO recursion not really necessary :-(
  return prev;
}

template<class type>
void disjoint<type>::join(disjoint<type>* jnt) {
  disjoint<type>* rt0=     find();
  disjoint<type>* rt1=jnt->find();
  if (rt0->rank>rt1->rank)
    rt1->prev=rt0;
  else
    if (rt0->rank<rt1->rank)
      rt0->prev=rt1;
    else
      if (rt0!=rt1) {
        rt1->prev=rt0;
        ++rt0->rank;
      }
}

#endif
