// code by jph

// TODO check draw() functions (as get executed multiple times per interation!)

#define _CRT_SECURE_NO_DEPRECATE  // no warnings when using std::c in vcpp compiler 14

#define NDEBUG
#define TENSOR_SVD_NDEBUG

#define GLEW_INCLUDE

#include "../_util/_opengl.hpp"
#include "../_util/audio.hpp"
#include "../_extern/pthread.h"
#include "../_animated/_animated.hpp"

aniAvatar*            ava;
aniCamera*            cam;
aniWave*              wav;
aniBoat*              din;
aniFloatable*         flo;
aniApache*            apa;
aniForest*            fst=0;

int                   FACTOR=20; // formerly 20

opengl_light*         light_top;
opengl_light*         light_sid;

tensor<double>        ext(1,2);

double camera_ang=0;
double camera_hgt=13;
rapid_touch tch;

meshgl* sky=opengl_meshgl("get/mesh/sky_138_tnv");
uint bsh;

// TODO also show bitmap of the world (as texture on quad) as kind of hud
// TODO draw mesh upside down when underwater
// TODO sphere map !!!

double mxx;
double mxy;

void configuration(int type) { // defines body and collision characteristics

  SYSTEM_INFO system_info;
  GetSystemInfo(&system_info);
  printf("NumberOfProcessors: %i\n",system_info.dwNumberOfProcessors);

  opengl_floor=1;  
  opengl_clearcolor.as( 102.0/255, 177.0/255, 239.0/255, 0.0);
  
  

  meshgl* gnd=opengl_meshgl("get/mesh/canyon_tcnv");
  gnd->texture=opengl_texture("get/tensor/gravel.bmp");
  fst=new aniForest(gnd);
  fst->tre<<=new aniTree("get/tensor/barkpine.bmp",3.0,20.0);
  fst->tre<<=new aniTree("get/tensor/palmpine.bmp",1.2, 8.0);
  fst->tre<<=new aniTree("get/tensor/realpalm.bmp",2.0,12.0);
  tensor<float> hgt("get/mesh/canyon_height.arr");
  fst->trees(hgt,5);
  fst->grass(hgt);
  //fst->tre(0)->wid=3;
  //
  //fst->tre(1)->tex=opengl_texture("get/tensor/palmpine.tex");
  //fst->tre(1)->wid=1.2;
  
  aniWorld::singleton()->animated.add(fst);
  
  mxx=gnd->arr(9,gnd->arr.size[1]-1);
  mxy=gnd->arr(10,gnd->arr.size[1]-1);
  ext(0)=mxx;
  ext(1)=mxy;
  printf("EXT %s\n",ext.toString());
  
  //gnd->shd_=shadow_static(gnd->msh,light_sid);
  
  wav=new aniWave(system_info.dwNumberOfProcessors,60,50,mxx,mxy);
  tensor<double> edg("get/mesh/canyon_edges.arr");
  wav->edges(edg);
  wav->texture_wav=opengl_texture("get/tensor/water2.bmp");
  wav->texture_ref=opengl_texture("get/tensor/cloudrefs.bmp");
  aniWorld::singleton()->animated.add(wav);
  
  din=new aniBoat();
  din->pos=glD(tensor<double>::vector(3).as( 0.0,-0.0, 0.3)).exp();
  din->pos(0,3)=ext(0)/2;
  din->pos(1,3)=ext(1)/2;
  aniWorld::singleton()->animated.add(din);
  aniMated::humanized=din;
  
  //apa=new aniApache();
  //linked_ani.add(apa);
  
  cam=new aniCamera();
  cam->focus(din,tensor<double>(1,4).as(-10.0, 0.0, 5.0, 1.0));
  aniWorld::singleton()->animated.add(cam);
  
  flo=new aniFloatable("get/mesh/sphere_224_tnv",
                       "get/mesh/sphereint_84.arr",18.0, // 386 466
                       "get/mesh/sphereext_224_v.arr",
                       "get/mesh/sphereext_224_n.arr",50.0);
  flo->pos=din->pos*glT(tensor<double>(1,4).as(12.0, 0.0, 5.0, 0.0));
  flo->ine*=0.1;
  aniWorld::singleton()->animated.add(flo);
  
  double fac=250;
  tensor<double> map=tensor<double>::matrix(4,4).as(
    fac, 0.0, 0.0, 0.0,
    0.0, fac, 0.0, 0.0,
    0.0, 0.0, fac, 0.0,
    mxx*0.5, mxy*0.5, 0.0, 1.0
  );
  *sky=sky->map(map);
  sky->texture=opengl_texture("get/tensor/sky_day.bmp");
  aniMated::humanized=ava;
}

linked<int> testprt[4];

int main(int argc,char** argv) {  
  opengl_recording_numel=600;
  opengl_recording_frame=1;     // take shot every x frames
  opengl_size.as(1280,720);
  opengl_position.as(70,5);
  opengl_main(argc,argv);
  
  audio::main();
  opengl_ambience=opengl_color_gray30;
  
  glFogi(GL_FOG_MODE, GL_EXP); // GL_LINEAR, GL_EXP2 Fog Mode
  glFogfv(GL_FOG_COLOR, opengl_color_blue.to<float>().data); // Set Fog Color
  glFogf(GL_FOG_DENSITY, 0.01f); // How Dense Will The Fog Be
  glHint(GL_FOG_HINT, GL_NICEST); // Fog Hint Value
  glFogf(GL_FOG_START, 1.0f); // Fog Start Depth
  glFogf(GL_FOG_END, 100.0f); // Fog End Depth
  
  ava=new aniAvatar();
  ava->pos(2,3)=3;
  ava->fva=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  ava->fot=tensor<double>(1,4).as( 0.3, 0.3, 0.3, 0.0);
  aniMated::humanized=ava;
  
  //light_top=new opengl_light();
  //light_top->dif=tensor<double>(1,4).as( 0.3, 0.3, 0.2, 0.0); // TODO try without a=1.0
  
  light_sid=new opengl_light();
  light_sid->dif=tensor<double>(1,4).as( 0.5, 0.5, 0.5, 0.0); // TODO try without a=1.0
  light_sid->pos(0,3)=100;
  light_sid->pos(1,3)=50;
  light_sid->pos(2,3)=200;

	configuration(0);
	
	tensor<double> lod("get/tensor/avatar.pos");
  if (lod.data)
    ava->pos=lod;
  printf("%s\n",ava->pos.toString());
  aniMated::humanized=din;
  glutMainLoop();
  return 0;
}

void scene(void) {
  int c0,c1,c2;
  aniMated* ani;
  aniMated::dt=min(opengl_rate.s(),1/12.5);
  opengl_bulletin.add(tensor<double>::string( aniMated::dt ));

  ava->relax();
  ava->scene();
  ava->motion();
  
  wav->setSpeed(10*opengl_slider("wave->set_speed",0.6));
    
  if (keyboard_down('1'))
    aniMated::humanized=ava;
  if (keyboard_down('2'))
    aniMated::humanized=din;
    
  if (keyboard_down('q'))
    flo->pos=din->pos*glT(tensor<double>(1,4).as( 8.0, 0.0, 5.0, 0.0));
    
  while (aniWorld::singleton()->animated.token(ani)) 
    ani->relax(); // body: acc=tor=0        
  
  if (fst) {
    aniMated::collide(fst,din);
    aniMated::collide(fst,cam);
    aniMated::collide(fst,flo);
  }
  aniMated::collide(din,flo);

  din->sub=wav->submerge(din->pos*din->lev);

  while (aniWorld::singleton()->animated.token(ani))
    ani->scene();

  wav->buoyancy(din);
  wav->interact(din);
  
  flo->acc-=glI(flo->pos)[2]*9.81;
  wav->buoyancy(flo);
  wav->interact(flo);

  float vol;
  FMOD_SoundGroup_GetVolume(audio::master,&vol);
  //FMOD_SoundGroup_SetVolume(audio::master,opengl_slider("audio volume",vol));

  while (aniWorld::singleton()->animated.token(ani))
    ani->motion(); // body: move      

  if (keyboard_down('z')) {
    ava->pos=tensor<double>::eye(4);
    //ava->pos(0,3)=0;
    //ava->pos(1,3)=0;
  }

  double fq=1,ra=5;
  //light_top->pos=glT(din->pos[3])*glT(tensor<double>(1,4).as(-5.0, 5.0, 5.0, 0.0));
  

  if (aniMated::humanized==din) {
    tensor<double> lev=tensor<double>(1,4).as( 0.0,-50.0,camera_hgt, 0.0);
    lev*=opengl_slider("camera distance",0.5);
    tensor<double> ups=tensor<double>::vector(4).as(0.0,0.0,lev.norm()*0.2,0.0);
    lev(3)=1;
    ava->pos=glLookAt(glT(din->pos[3])*glD(tensor<double>(1,4).as( 0.0, 0.0, camera_ang, 0.0)).exp()*lev,din->pos[3]+ups);
    camera_ang+=mouse_drag(0)*2;
    camera_hgt+=mouse_drag(1)*20;
  }
  
  //printf("%s\n\n",glI(opengl_camera).toString());
  
  opengl_camera=ava->pos;
    
  if (wav->submerge(opengl_camera[3])<0)
    glEnable(GL_FOG);
  else
    glDisable(GL_FOG);
  audio::listen(opengl_camera,tensor<double>(1,4));  
  opengl_camera=glI(opengl_camera); // TODO odd !!!
  //opengl_camera=cam->opengl();
}
void grass(void);

void display(void) {
  aniMated* ani;
  while (aniWorld::singleton()->animated.token(ani))
    ani->draw_std();    
  //grass();
  //if (tch.num) {
  //  glPushMatrix();
  //  glMultMatrixd(glT(tch.pnt).data);
  //  glColor3dv(opengl_color_red.data);
  //  glutSolidSphere(0.05,10,10);
  //  glPopMatrix();   
  //}
  //meshgl::surface(hgt).draw();
  
  //printf("%i\n",blu.point.numel);

}

void shadow(opengl_light* lgt) {
  aniMated* ani;
  while (aniWorld::singleton()->animated.token(ani))
    ani->shadow(lgt->pos[3]);
}

void finish(void) {
  glPushAttrib(GL_ENABLE_BIT);  
    glDisable(GL_LIGHTING);    
    sky->draw();
    //fst->draw_std();
    fst->grass();
  glPopAttrib();
  wav->blit(din->pos[3]);
  
}


